#include "ext.h"
#include "z_dsp.h"

void *dirac_class;

typedef struct _dirac
{
    t_pxobject	x_obj;
    double 		module;
    short		one_shot;

} t_dirac, *t_dirac_ptr;

t_int *dirac_perform(t_int *w);
void *dirac_new(double initial_module);
void dirac_dsp(t_dirac *x, t_signal **sp, short *count);
void dirac_float(t_dirac *x, double f);
void dirac_bang(t_dirac *x);
void dirac_set(t_dirac *x, double f);
// void dirac_assist(t_dirac *x, void *b, long m, long a, char *s);

void main(void)
{
    setup((t_messlist **) &dirac_class, (method) dirac_new, (method)dsp_free, (short)sizeof(t_dirac), 0L,A_DEFFLOAT,0);
    addmess((method)dirac_dsp, "dsp", A_CANT, 0);
    // addftx((method)dirac_float,1);
    addbang((method) dirac_bang);
    addfloat((method) dirac_float);
    // addmess((method)dirac_assist,"assist",A_CANT,0);
    addmess((method)dirac_set,"set",A_DEFFLOAT,0);
    // post("dirac~ UB 2007.II.08  updated OSX 10.6 @ Gilbert Nouno");
	post("gn.dirac~ Intel Only OSX 10.6 compiled %s %s @ Gilbert Nouno",__DATE__,__TIME__);
    dsp_initclass(); // set object class to work with MSP
    rescopy('STR#',4100);
}

/*void dirac_assist(t_dirac *x, void *b, long m, long a, char *s)
{
	assist_string(4100,m,a,1,2,s);
}*/

void *dirac_new(double initial_module)
{
    t_dirac *x = (t_dirac *)newobject(dirac_class);
    dsp_setup((t_pxobject *)x,0); // dirac has no input signal
    // floatin((t_dirac *)x,1);
    outlet_new((t_pxobject *)x, "signal");
    // intialisation
    x->module 	= 	(initial_module == 0.) ? 1.0 : initial_module;
    x->one_shot = 	0;
    // x->x_obj.z_misc	=	Z_NO_INPLACE;
    return (x);
}

void dirac_dsp(t_dirac *x, t_signal **sp, short *count)
{
	dsp_add(dirac_perform, 3, x, sp[0]->s_vec, sp[0]->s_n);
}

t_int *dirac_perform(t_int *w)
{	
	t_dirac *x 	= (t_dirac *)(w[1]);
	float *out 	= (float *)(w[2]);
	int	n 		= (int)(w[3]);	

	if(x->one_shot) {
		*out++ = x->module; // on sort la premire valeur du vecteur comme un dirac~
		x->one_shot = 0;
		n--;
		while (n--) {
			*out++ = 0.;
		}
	}
	else {
			while (n--) {
			*out++ = 0.;
			}
		}		
	return (w+4);
}
			
void dirac_float(t_dirac *x, double f)
{
	x->module = f;
	x->one_shot = 1; // enable auto-shot next signal vector
}

void dirac_bang(t_dirac *x)
{
	x->one_shot = 1;
}

void dirac_set(t_dirac *x, double f)
{
	x->module = f;
	x->one_shot = 0; // disable auto-shot next signal vector
}

